$mq-smartphone-width: 480px;
$mq-tablet-width: 768px;
$mq-desktop-width: 1024px;
$mq-large-desktop-width: 1440px;

@mixin mq-small-smartphone {
  @media (max-width: #{$mq-smartphone-width - 1px}) {
    @content;
  }
}

@mixin mq-smartphone {
  @media (max-width: #{$mq-tablet-width - 1px}) {
    @content;
  }
}

@mixin mq-tablet {
  @media (max-width: #{$mq-desktop-width - 1px}) {
    @content;
  }
}

@mixin mq-large-desktop {
  @media (min-width: #{$mq-large-desktop-width}) {
    @content;
  }
}

@mixin mq-retina {
  @media screen and (-webkit-min-device-pixel-ratio: 2), (min-resolution: 192dpi) {
    @content;
  }
}

@mixin nav-list() {
  ul, ol {
    margin: 0;
    padding: 0;
    list-style-type: none;

    li {
      margin: 0;
      padding: 0;

      a {
        display: block;
      }
    }
  }
}

@mixin standard-list() {
  ul {
    margin: 0 0 20px;
    padding: 0;
    list-style-type: none;

    li {
      position: relative;
      margin: 0 0 5px;
      padding: 0 0 0 20px;

      &:before {
        content: "";
        display: block;
        position: absolute;
        top: 10px;
        left: 5px;
        width: 6px;
        height: 6px;
        background-color: $color-highlight;
      }
    }
  }
}

@mixin hyphenate() {
  overflow-wrap: break-word;
  word-wrap: break-word;
  -webkit-hyphens: auto;
  -moz-hyphens: auto;
  -ms-hyphens: auto;
  hyphens: auto;
}

@mixin text-overflow($lh, $lc) {
  display: block;
  display: -webkit-box;
  height: #{$lh * $lc}em;
  line-height: #{$lh}em;
  -webkit-line-clamp: $lc;
  -webkit-box-orient: vertical;
  overflow: hidden;
  text-overflow: ellipsis;
}

@mixin hidden-text() {
  line-height: 0;
  font-size: 0;
  color: transparent;
}

@mixin hidden-input() {
  position: absolute;
  clip: rect(0, 0, 0, 0);
}

@mixin sr-only() {
  border: 0;
  clip: rect(0 0 0 0);
  height: 1px;
  margin: -1px;
  overflow: hidden;
  padding: 0;
  position: absolute;
  width: 1px;
}

@mixin opacity($opacity) {
  opacity: $opacity;
  $opacity-ie: $opacity * 100;
  filter: alpha(opacity=$opacity-ie);
}

@mixin box-sizing($value) {
  -webkit-box-sizing: $value;
  -moz-box-sizing: $value;
  box-sizing: $value;
}

@mixin force-hardware-acceleration() {
  -webkit-transform: translateZ(0);
  transform: translateZ(0);
  -webkit-backface-visibility: hidden;
  backface-visibility: hidden;
  -webkit-perspective: 1000;
  perspective: 1000;
}

@mixin transition($transitions...) {
  -webkit-transition: $transitions;
  transition: $transitions;
}

@mixin transform($transforms) {
  -webkit-transform: $transforms;
  -ms-transform: $transforms;
  transform: $transforms;
}

@mixin rotate ($deg) {
  @include transform(rotate(#{$deg}deg));
}

@mixin scale($scale) {
  @include transform(scale($scale));
}

@mixin translate ($x, $y) {
  @include transform(translate($x, $y));
}

@mixin skew ($x, $y) {
  @include transform(skew(#{$x}deg, #{$y}deg));
}

@mixin background-opacity($color, $opacity: 0.3) {
  background-color: $color;
  background-color: rgba($color, $opacity);
}

@mixin gradient-horizontal($start-color: #555, $end-color: #333, $start-percent: 0%, $end-percent: 100%) {
  background-image: -webkit-linear-gradient(left, $start-color $start-percent, $end-color $end-percent); // Safari 5.1-6, Chrome 10+
  background-image: -o-linear-gradient(left, $start-color $start-percent, $end-color $end-percent); // Opera 12
  background-image: linear-gradient(to right, $start-color $start-percent, $end-color $end-percent); // Standard, IE10, Firefox 16+, Opera 12.10+, Safari 7+, Chrome 26+
  background-repeat: repeat-x;
  filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#{ie-hex-str($start-color)}', endColorstr='#{ie-hex-str($end-color)}', GradientType=1); // IE9 and down
}

@mixin gradient-vertical($start-color: #555, $end-color: #333, $start-percent: 0%, $end-percent: 100%) {
  background-image: -webkit-linear-gradient(top, $start-color $start-percent, $end-color $end-percent);  // Safari 5.1-6, Chrome 10+
  background-image: -o-linear-gradient(top, $start-color $start-percent, $end-color $end-percent);  // Opera 12
  background-image: linear-gradient(to bottom, $start-color $start-percent, $end-color $end-percent); // Standard, IE10, Firefox 16+, Opera 12.10+, Safari 7+, Chrome 26+
  background-repeat: repeat-x;
  filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#{ie-hex-str($start-color)}', endColorstr='#{ie-hex-str($end-color)}', GradientType=0); // IE9 and down
}